## zycore-c 1.1.0

=== CMakeLists.txt ===
if (TARGET Zycore)
    return()
endif ()

cmake_minimum_required(VERSION 3.1 FATAL_ERROR)

project(Zycore VERSION 1.1.0.0 LANGUAGES C CXX)

include(GenerateExportHeader)
include(GNUInstallDirs)
include(CMakePackageConfigHelpers)

# =============================================================================================== #
# Overridable options                                                                             #
# =============================================================================================== #

# Global configuration
option(ZYAN_WHOLE_PROGRAM_OPTIMIZATION
    "Enable whole program optimization (all targets)"
    OFF)
option(ZYAN_NO_LIBC
    "Don't use any C standard library functions (for exotic build-envs like kernel drivers)"
    OFF)
option(ZYAN_DEV_MODE
    "Enable developer mode (-Wall, -Werror, ...)"
    OFF)
option(ZYAN_FORCE_ASSERTS
    "Forces asserts in release builds."
    OFF)

# Build configuration
option(ZYCORE_BUILD_SHARED_LIB
    "Build shared library"
    OFF)
option(ZYCORE_BUILD_EXAMPLES
    "Build examples"
    OFF)
option(ZYCORE_BUILD_TESTS
    "Build tests"
    OFF)

# =============================================================================================== #
# Forced assertions hack                                                                          #
# =============================================================================================== #

# The code for this is adapted from how LLVM forces asserts.
if (ZYAN_FORCE_ASSERTS)
    set(vars
        CMAKE_CXX_FLAGS_RELEASE
        CMAKE_CXX_FLAGS_RELWITHDEBINFO
        CMAKE_CXX_FLAGS_MINSIZEREL
        CMAKE_C_FLAGS_RELEASE
        CMAKE_C_FLAGS_RELWITHDEBINFO
        CMAKE_C_FLAGS_MINSIZEREL)

    foreach (var ${vars})
        string (REGEX REPLACE "(^| )[/-]D *NDEBUG($| )" " " "${var}" "${${var}}")
        set("${var}" "${${var}} -UNDEBUG" CACHE STRING "" FORCE)
    endforeach()
endif ()

# =============================================================================================== #
# GoogleTest                                                                                      #
# =============================================================================================== #

# Download and unpack googletest
if (ZYCORE_BUILD_TESTS)
    if (NOT DEFINED ZYCORE_DOWNLOADED_GTEST)
        configure_file("CMakeLists.txt.in" "${CMAKE_BINARY_DIR}/gtest/download/CMakeLists.txt")
        execute_process(COMMAND ${CMAKE_COMMAND} -G "${CMAKE_GENERATOR}" .
            RESULT_VARIABLE result
            WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/gtest/download")
        if (result)
            message(FATAL_ERROR "CMake step for googletest failed: ${result}")
        endif()
        execute_process(COMMAND ${CMAKE_COMMAND} --build .
            RESULT_VARIABLE result
            WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/gtest/download")
        if (result)
            message(FATAL_ERROR "Build step for googletest failed: ${result}")
        endif()

        set(ZYCORE_DOWNLOADED_GTEST TRUE CACHE BOOL "")
        mark_as_advanced(ZYCORE_DOWNLOADED_GTEST)
    endif ()

    set(gtest_force_shared_crt ON CACHE BOOL "" FORCE)

    add_subdirectory("${CMAKE_BINARY_DIR}/gtest/src" "${CMAKE_BINARY_DIR}/gtest/build"
        EXCLUDE_FROM_ALL)
endif ()

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
include(zyan-functions)

# =============================================================================================== #
# Library configuration                                                                           #
# =============================================================================================== #

if (ZYCORE_BUILD_SHARED_LIB)
    add_library("Zycore" SHARED)
else ()
    add_library("Zycore" STATIC)
endif ()

set_target_properties("Zycore" PROPERTIES
    LINKER_LANGUAGE C
    VERSION ${Zycore_VERSION}
    SOVERSION ${Zycore_VERSION_MAJOR}.${Zycore_VERSION_MINOR})
target_include_directories("Zycore"
    PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
        $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}>
        $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
    PRIVATE "src")
target_compile_definitions("Zycore" PRIVATE "_CRT_SECURE_NO_WARNINGS" "ZYCORE_EXPORTS")
zyan_set_common_flags("Zycore")
zyan_maybe_enable_wpo_for_lib("Zycore")
generate_export_header("Zycore" BASE_NAME "ZYCORE" EXPORT_FILE_NAME "ZycoreExportConfig.h")

if (ZYAN_NO_LIBC)
    target_compile_definitions("Zycore" PUBLIC "ZYAN_NO_LIBC")
    if (UNIX)
        set_target_properties("Zycore" PROPERTIES LINK_FLAGS "-nostdlib -nodefaultlibs")
    endif ()
endif ()

target_sources("Zycore"
    PRIVATE
        # API
        "${CMAKE_CURRENT_LIST_DIR}/include/Zycore/API/Memory.h"
        "${CMAKE_CURRENT_LIST_DIR}/include/Zycore/API/Process.h"
        "${CMAKE_CURRENT_LIST_DIR}/include/Zycore/API/Synchronization.h"
        "${CMAKE_CURRENT_LIST_DIR}/include/Zycore/API/Terminal.h"
        "${CMAKE_CURRENT_LIST_DIR}/include/Zycore/API/Thread.h"
        # Common
        "${CMAKE_CURRENT_LIST_DIR}/include/Zycore/Allocator.h"
        "${CMAKE_CURRENT_LIST_DIR}/include/Zycore/ArgParse.h"
        "${CMAKE_CURRENT_LIST_DIR}/include/Zycore/Bitset.h"
        "${CMAKE_CURRENT_LIST_DIR}/include/Zycore/Comparison.h"
        "${CMAKE_CURRENT_LIST_DIR}/include/Zycore/Defines.h"
        "${CMAKE_CURRENT_LIST_DIR}/include/Zycore/Format.h"
        "${CMAKE_CURRENT_LIST_DIR}/include/Zycore/LibC.h"
        "${CMAKE_CURRENT_LIST_DIR}/include/Zycore/List.h"
        "${CMAKE_CURRENT_LIST_DIR}/include/Zycore/Object.h"
        "${CMAKE_CURRENT_LIST_DIR}/include/Zycore/Status.h"
        "${CMAKE_CURRENT_LIST_DIR}/include/Zycore/String.h"
        "${CMAKE_CURRENT_LIST_DIR}/include/Zycore/Types.h"
        "${CMAKE_CURRENT_LIST_DIR}/include/Zycore/Vector.h"
        "${CMAKE_CURRENT_LIST_DIR}/include/Zycore/Zycore.h"
        # API
        "src/API/Memory.c"
        "src/API/Process.c"
        "src/API/Synchronization.c"
        "src/API/Terminal.c"
        "src/API/Thread.c"
        # Common
        "src/Allocator.c"
        "src/ArgParse.c"
        "src/Bitset.c"
        "src/Format.c"
        "src/List.c"
        "src/String.c"
        "src/Vector.c"
        "src/Zycore.c")

if (ZYCORE_BUILD_SHARED_LIB AND WIN32)
    target_sources("Zycore" PRIVATE "resources/VersionInfo.rc")
endif ()

zyan_set_source_group("Zycore")

if (${CMAKE_SYSTEM_NAME} STREQUAL "Linux" AND NOT ZYAN_NO_LIBC)
    target_compile_definitions("Zycore" PRIVATE "_GNU_SOURCE")
    find_package(Threads REQUIRED)
    target_link_libraries("Zycore" Threads::Threads)
endif ()

configure_package_config_file(cmake/zycore-config.cmake.in
    "${CMAKE_CURRENT_BINARY_DIR}/zycore-config.cmake"
    INSTALL_DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/zycore"
)
write_basic_package_version_file(
    "${CMAKE_CURRENT_BINARY_DIR}/zycore-config-version.cmake"
    COMPATIBILITY SameMajorVersion
)
install(FILES
    "cmake/zyan-functions.cmake"
    "${CMAKE_CURRENT_BINARY_DIR}/zycore-config.cmake"
    "${CMAKE_CURRENT_BINARY_DIR}/zycore-config-version.cmake"
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/zycore"
)

install(TARGETS "Zycore" EXPORT "zycore-targets")
install(EXPORT "zycore-targets"
    NAMESPACE "Zycore::"
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/zycore")
install(FILES
    "${PROJECT_BINARY_DIR}/ZycoreExportConfig.h"
    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")
install(DIRECTORY "include/" DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

# =============================================================================================== #
# Developer mode                                                                                  #
# =============================================================================================== #

if (ZYAN_DEV_MODE)
    set_property(GLOBAL PROPERTY USE_FOLDERS ON)
endif ()

# =============================================================================================== #
# Examples                                                                                        #
# =============================================================================================== #

if (ZYCORE_BUILD_EXAMPLES)
    add_executable("String" "examples/String.c")
    zyan_set_common_flags("String" "Zycore")
    target_link_libraries("String" "Zycore")
    set_target_properties("String" PROPERTIES FOLDER "Examples")
    target_compile_definitions("String" PRIVATE "_CRT_SECURE_NO_WARNINGS")
    zyan_maybe_enable_wpo("String")

    add_executable("Vector" "examples/Vector.c")
    zyan_set_common_flags("Vector" "Zycore")
    target_link_libraries("Vector" "Zycore")
    set_target_properties("Vector" PROPERTIES FOLDER "Examples")
    target_compile_definitions("Vector" PRIVATE "_CRT_SECURE_NO_WARNINGS")
    zyan_maybe_enable_wpo("Vector")
endif ()

# =============================================================================================== #
# Tests                                                                                           #
# =============================================================================================== #

function (zyan_add_test test)
    add_executable("Test${test}" "tests/${test}.cpp")

    if (NOT MSVC)
        target_compile_options("Test${test}" PRIVATE "-std=c++17")
    endif ()

    target_link_libraries("Test${test}" "Zycore")
    target_link_libraries("Test${test}" "gtest")
    set_target_properties("Test${test}" PROPERTIES FOLDER "Tests")
    target_compile_definitions("Test${test}" PRIVATE "_CRT_SECURE_NO_WARNINGS")
    zyan_maybe_enable_wpo("Test${test}")
endfunction ()

if (ZYCORE_BUILD_TESTS)
    zyan_add_test("String")
    zyan_add_test("Vector")
    zyan_add_test("ArgParse")
endif ()

# =============================================================================================== #

=== debian/changelog ===
zycore-c (1.1.0-4) unstable; urgency=medium

  * d/control:
    - use any-arm instead of any-armel and any-armhf also for zycore-dev
    - add Vcs fields
    - mark test deps with <!nocheck>
  * d/rules: add qa=+all option
  * d/watch: use GitHub's API

 -- Andrea Pappacoda <andrea@pappacoda.it>  Tue, 07 Dec 2021 12:43:25 +0100

zycore-c (1.1.0-3) unstable; urgency=medium

  * d/control: use any-arm instead of any-armel and any-armhf

 -- Andrea Pappacoda <andrea@pappacoda.it>  Tue, 16 Nov 2021 10:21:00 +0100

zycore-c (1.1.0-2) unstable; urgency=medium

  * Source-only reupload

 -- Andrea Pappacoda <andrea@pappacoda.it>  Mon, 15 Nov 2021 21:37:57 +0100

zycore-c (1.1.0-1) unstable; urgency=medium

  * New upstream release.
  * d/control: restrict build to x86 and ARM. Closes: #999494
  * d/watch: use GitHub tags instead of GitHub releases
  * d/rules: build and run tests

 -- Andrea Pappacoda <andrea@pappacoda.it>  Fri, 12 Nov 2021 13:15:38 +0100

zycore-c (1.0.0-2) unstable; urgency=medium

  * Backport ZYAN_NO_SANITIZE macro (needed to build Zydis 3.2.1)
  * Backport ZyanAbsI64() function (needed to build Zydis 3.2.1)

 -- Andrea Pappacoda <andrea@pappacoda.it>  Thu, 11 Nov 2021 12:21:07 +0100

zycore-c (1.0.0-1) unstable; urgency=low

  * Initial release. Closes: #995884

 -- Andrea Pappacoda <andrea@pappacoda.it>  Thu, 07 Oct 2021 18:14:34 +0200

=== debian/control ===
Source: zycore-c
Section: libs
Priority: optional
Maintainer: Andrea Pappacoda <andrea@pappacoda.it>
Build-Depends: cmake (>= 3.1),
               debhelper-compat (= 13),
               libgtest-dev <!nocheck>
Standards-Version: 4.6.0
Homepage: https://github.com/zyantific/zycore-c
Vcs-Git: https://salsa.debian.org/debian/zycore-c.git
Vcs-Browser: https://salsa.debian.org/debian/zycore-c
Rules-Requires-Root: no

Package: libzycore1.1
Architecture: any-amd64 any-arm any-arm64 any-i386
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Zyan Core Library for C
 Zyan Core is an internal library providing platform independent types,
 macros and a fallback for environments without LibC.
 .
 This package contains the shared library.

Package: libzycore-dev
Section: libdevel
Architecture: any-amd64 any-arm any-arm64 any-i386
Depends: libzycore1.1 (= ${binary:Version}),
         ${misc:Depends}
Description: Zyan Core Library for C - development
 Zyan Core is an internal library providing platform independent types,
 macros and a fallback for environments without LibC.
 .
 This package contains the development files.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all qa=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DBUILD_SHARED_LIBS=ON \
		-DZYAN_WHOLE_PROGRAM_OPTIMIZATION=ON \
		-DZYCORE_BUILD_SHARED_LIB=ON \
		-DZYCORE_BUILD_TESTS=ON

## zycore-c 1.4.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,11 +2,15 @@
     return()
 endif ()
 
-cmake_minimum_required(VERSION 3.1 FATAL_ERROR)
-
-project(Zycore VERSION 1.1.0.0 LANGUAGES C CXX)
-
-include(GenerateExportHeader)
+cmake_minimum_required(VERSION 3.9 FATAL_ERROR)
+
+if (CMAKE_VERSION VERSION_GREATER_EQUAL "3.15")
+    # Enable runtime library selection via CMAKE_MSVC_RUNTIME_LIBRARY
+    cmake_policy(SET CMP0091 NEW)
+endif ()
+
+project(Zycore VERSION 1.4.0.0 LANGUAGES C)
+
 include(GNUInstallDirs)
 include(CMakePackageConfigHelpers)
 
@@ -63,31 +67,42 @@
 # GoogleTest                                                                                      #
 # =============================================================================================== #
 
-# Download and unpack googletest
+# Search for GoogleTest, and fallback to downloading it if not found
 if (ZYCORE_BUILD_TESTS)
-    if (NOT DEFINED ZYCORE_DOWNLOADED_GTEST)
-        configure_file("CMakeLists.txt.in" "${CMAKE_BINARY_DIR}/gtest/download/CMakeLists.txt")
-        execute_process(COMMAND ${CMAKE_COMMAND} -G "${CMAKE_GENERATOR}" .
-            RESULT_VARIABLE result
-            WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/gtest/download")
-        if (result)
-            message(FATAL_ERROR "CMake step for googletest failed: ${result}")
-        endif()
-        execute_process(COMMAND ${CMAKE_COMMAND} --build .
-            RESULT_VARIABLE result
-            WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/gtest/download")
-        if (result)
-            message(FATAL_ERROR "Build step for googletest failed: ${result}")
-        endif()
-
-        set(ZYCORE_DOWNLOADED_GTEST TRUE CACHE BOOL "")
-        mark_as_advanced(ZYCORE_DOWNLOADED_GTEST)
-    endif ()
+    find_package(GTest QUIET)
+    if (GTest_FOUND)
+        # CMake 3.20 and upstream GTestConfig.cmake
+        if (TARGET GTest::gtest)
+            add_library(gtest ALIAS GTest::gtest)
+        # Older FindGTest
+        else ()
+            add_library(gtest ALIAS GTest::GTest)
+        endif ()
+    else ()
+        if (NOT DEFINED ZYCORE_DOWNLOADED_GTEST)
+            configure_file("CMakeLists.txt.in" "${CMAKE_BINARY_DIR}/gtest/download/CMakeLists.txt")
+            execute_process(COMMAND ${CMAKE_COMMAND} -G "${CMAKE_GENERATOR}" .
+                RESULT_VARIABLE result
+                WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/gtest/download")
+            if (result)
+                message(FATAL_ERROR "CMake step for googletest failed: ${result}")
+            endif()
+            execute_process(COMMAND ${CMAKE_COMMAND} --build .
+                RESULT_VARIABLE result
+                WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/gtest/download")
+            if (result)
+                message(FATAL_ERROR "Build step for googletest failed: ${result}")
+            endif()
+
+            set(ZYCORE_DOWNLOADED_GTEST TRUE CACHE BOOL "")
+            mark_as_advanced(ZYCORE_DOWNLOADED_GTEST)
+        endif ()
 
     set(gtest_force_shared_crt ON CACHE BOOL "" FORCE)
 
     add_subdirectory("${CMAKE_BINARY_DIR}/gtest/src" "${CMAKE_BINARY_DIR}/gtest/build"
         EXCLUDE_FROM_ALL)
+    endif ()
 endif ()
 
 list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
@@ -101,22 +116,23 @@
     add_library("Zycore" SHARED)
 else ()
     add_library("Zycore" STATIC)
+    target_compile_definitions("Zycore" PUBLIC "ZYCORE_STATIC_BUILD")
 endif ()
 
 set_target_properties("Zycore" PROPERTIES
     LINKER_LANGUAGE C
-    VERSION ${Zycore_VERSION}
-    SOVERSION ${Zycore_VERSION_MAJOR}.${Zycore_VERSION_MINOR})
+    VERSION "${Zycore_VERSION}"
+    SOVERSION "${Zycore_VERSION_MAJOR}.${Zycore_VERSION_MINOR}"
+    DEFINE_SYMBOL "ZYCORE_SHOULD_EXPORT")
 target_include_directories("Zycore"
     PUBLIC
         $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
         $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}>
         $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
     PRIVATE "src")
-target_compile_definitions("Zycore" PRIVATE "_CRT_SECURE_NO_WARNINGS" "ZYCORE_EXPORTS")
+target_compile_definitions("Zycore" PRIVATE "_CRT_SECURE_NO_WARNINGS")
 zyan_set_common_flags("Zycore")
-zyan_maybe_enable_wpo_for_lib("Zycore")
-generate_export_header("Zycore" BASE_NAME "ZYCORE" EXPORT_FILE_NAME "ZycoreExportConfig.h")
+zyan_maybe_enable_wpo("Zycore")
 
 if (ZYAN_NO_LIBC)
     target_compile_definitions("Zycore" PUBLIC "ZYAN_NO_LIBC")
@@ -136,6 +152,7 @@
         # Common
         "${CMAKE_CURRENT_LIST_DIR}/include/Zycore/Allocator.h"
         "${CMAKE_CURRENT_LIST_DIR}/include/Zycore/ArgParse.h"
+        "${CMAKE_CURRENT_LIST_DIR}/include/Zycore/Atomic.h"
         "${CMAKE_CURRENT_LIST_DIR}/include/Zycore/Bitset.h"
         "${CMAKE_CURRENT_LIST_DIR}/include/Zycore/Comparison.h"
         "${CMAKE_CURRENT_LIST_DIR}/include/Zycore/Defines.h"
@@ -148,6 +165,8 @@
         "${CMAKE_CURRENT_LIST_DIR}/include/Zycore/Types.h"
         "${CMAKE_CURRENT_LIST_DIR}/include/Zycore/Vector.h"
         "${CMAKE_CURRENT_LIST_DIR}/include/Zycore/Zycore.h"
+        "${CMAKE_CURRENT_LIST_DIR}/include/Zycore/Internal/AtomicGNU.h"
+        "${CMAKE_CURRENT_LIST_DIR}/include/Zycore/Internal/AtomicMSVC.h"
         # API
         "src/API/Memory.c"
         "src/API/Process.c"
@@ -172,6 +191,7 @@
 
 if (${CMAKE_SYSTEM_NAME} STREQUAL "Linux" AND NOT ZYAN_NO_LIBC)
     target_compile_definitions("Zycore" PRIVATE "_GNU_SOURCE")
+    set(THREADS_PREFER_PTHREAD_FLAG ON)
     find_package(Threads REQUIRED)
     target_link_libraries("Zycore" Threads::Threads)
 endif ()
@@ -191,14 +211,30 @@
     DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/zycore"
 )
 
-install(TARGETS "Zycore" EXPORT "zycore-targets")
+install(TARGETS "Zycore" EXPORT "zycore-targets"
+    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
+    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
+    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
+)
+
 install(EXPORT "zycore-targets"
     NAMESPACE "Zycore::"
     DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/zycore")
-install(FILES
-    "${PROJECT_BINARY_DIR}/ZycoreExportConfig.h"
-    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")
 install(DIRECTORY "include/" DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
+
+# =============================================================================================== #
+# Doxygen documentation                                                                           #
+# =============================================================================================== #
+
+find_package(Doxygen)
+if (DOXYGEN_FOUND)
+    doxygen_add_docs(ZycoreDoc "include/Zycore/" ALL)
+    install(
+        DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/html/"
+        DESTINATION "${CMAKE_INSTALL_DOCDIR}/api"
+        COMPONENT Documentation
+    )
+endif()
 
 # =============================================================================================== #
 # Developer mode                                                                                  #
@@ -234,19 +270,22 @@
 
 function (zyan_add_test test)
     add_executable("Test${test}" "tests/${test}.cpp")
-
-    if (NOT MSVC)
-        target_compile_options("Test${test}" PRIVATE "-std=c++17")
-    endif ()
-
-    target_link_libraries("Test${test}" "Zycore")
-    target_link_libraries("Test${test}" "gtest")
-    set_target_properties("Test${test}" PROPERTIES FOLDER "Tests")
+    target_link_libraries("Test${test}" "Zycore" "gtest")
+    set_target_properties("Test${test}" PROPERTIES
+        LANGUAGE CXX
+        CXX_STANDARD 17
+        CXX_EXTENSIONS OFF
+        CXX_STANDARD_REQUIRED ON
+        FOLDER "Tests"
+    )
     target_compile_definitions("Test${test}" PRIVATE "_CRT_SECURE_NO_WARNINGS")
     zyan_maybe_enable_wpo("Test${test}")
+    add_test("${test}" "Test${test}")
 endfunction ()
 
 if (ZYCORE_BUILD_TESTS)
+    enable_language(CXX)
+    enable_testing()
     zyan_add_test("String")
     zyan_add_test("Vector")
     zyan_add_test("ArgParse")

=== debian/changelog ===
zycore-c (1.4.1-2.1build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 15:56:22 +1100

zycore-c (1.4.1-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1063314

 -- Steve Langasek <vorlon@debian.org>  Thu, 29 Feb 2024 08:50:24 +0000

zycore-c (1.4.1-2) unstable; urgency=medium

  * d/patches: add loong64 support.
    Thanks to wuruilong for the patch! (Closes: #1059604)

 -- Andrea Pappacoda <andrea@pappacoda.it>  Fri, 12 Jan 2024 22:24:00 +0100

zycore-c (1.4.1-1) unstable; urgency=medium

  * New upstream version 1.4.1
  * Upload to unstable

 -- Andrea Pappacoda <andrea@pappacoda.it>  Sun, 20 Nov 2022 16:42:22 +0100

zycore-c (1.4.0-1) experimental; urgency=medium

  * New upstream version 1.4.0
  * d/control: libzycore1.2 -> libzycore1.4
  * d/control: add new libzycore-doc package
  * d/control: build on any architecture (Closes: #1015787)
  * d/patches: drop upstreamed patches

 -- Andrea Pappacoda <andrea@pappacoda.it>  Sun, 06 Nov 2022 23:24:02 +0100

zycore-c (1.2.0-2) unstable; urgency=medium

  * Upload to unstable
  * d/patches: build Doxygen documentation

 -- Andrea Pappacoda <andrea@pappacoda.it>  Fri, 30 Sep 2022 14:35:40 +0200

zycore-c (1.2.0-1) experimental; urgency=medium

  [ Andrea Pappacoda ]
  * New upstream version 1.2.0
  * d/control: libzycore1.1 -> libzycore1.2
  * d/control: mark Multi-Arch: same
  * d/patches: drop upstreamed patches
  * d/tests: add autopkgtests
  * d/upstream/metadata: add Donation field

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster

 -- Andrea Pappacoda <andrea@pappacoda.it>  Wed, 14 Sep 2022 13:23:42 +0200

=== debian/control ===
Source: zycore-c
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Andrea Pappacoda <andrea@pappacoda.it>
Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13)
Build-Depends-Arch: dpkg-dev (>= 1.22.5), cmake,
                    libgtest-dev <!nocheck>
Build-Depends-Indep: cmake,
                     libgtest-dev <!nocheck>,
                     doxygen <!nodoc>,
                     graphviz <!nodoc>
Standards-Version: 4.6.1
Homepage: https://github.com/zyantific/zycore-c
Vcs-Git: https://salsa.debian.org/debian/zycore-c.git
Vcs-Browser: https://salsa.debian.org/debian/zycore-c
Rules-Requires-Root: no

Package: libzycore1.4t64
Provides: ${t64:Provides}
Replaces: libzycore1.4
Breaks: libzycore1.4 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Zyan Core Library for C
 Zyan Core is an internal library providing platform independent types,
 macros and a fallback for environments without LibC.
 .
 This package contains the shared library.

Package: libzycore-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libzycore1.4t64 (= ${binary:Version}),
         ${misc:Depends}
Recommends: libzycore-doc
Description: Zyan Core Library for C - development
 Zyan Core is an internal library providing platform independent types,
 macros and a fallback for environments without LibC.
 .
 This package contains the development files.

Package: libzycore-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: libjs-jquery,
         ${misc:Depends}
Description: Zyan Core Library for C - documentation
 Zyan Core is an internal library providing platform independent types,
 macros and a fallback for environments without LibC.
 .
 This package contains the generated Doxygen documentation.

=== debian/watch ===
version=4
opts="searchmode=plain, \
  filenamemangle=s/.*v@ANY_VERSION@/@PACKAGE@-$1\.tar\.gz/, \
  pgpmode=none" \
https://api.github.com/repos/zyantific/zycore-c/tags \
https://api.github.com/repos/zyantific/zycore-c/tarball/refs/tags/v@ANY_VERSION@

## zycore-c 1.5.0

=== debian/changelog ===
zycore-c (1.5.0-1) unstable; urgency=medium

  * Init && sync with upstream

 -- Alphagocc <alphagocc@163.com>  Tue, 24 Sep 2024 18:15:54 +0800

=== debian/control ===
--- 
+++ 
@@ -1,25 +1,20 @@
 Source: zycore-c
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Andrea Pappacoda <andrea@pappacoda.it>
-Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13)
-Build-Depends-Arch: dpkg-dev (>= 1.22.5), cmake,
+Maintainer: Alphagocc <alphagocc@163.com>
+Build-Depends: dpkg-dev (>= 1.22.5), debhelper (>= 11)
+Build-Depends-Arch: cmake,
                     libgtest-dev <!nocheck>
 Build-Depends-Indep: cmake,
                      libgtest-dev <!nocheck>,
                      doxygen <!nodoc>,
                      graphviz <!nodoc>
-Standards-Version: 4.6.1
+Standards-Version: 4.7.0
 Homepage: https://github.com/zyantific/zycore-c
-Vcs-Git: https://salsa.debian.org/debian/zycore-c.git
-Vcs-Browser: https://salsa.debian.org/debian/zycore-c
+Vcs-Git: https://github.com/deepin-community/zycore-c
 Rules-Requires-Root: no
 
-Package: libzycore1.4t64
-Provides: ${t64:Provides}
-Replaces: libzycore1.4
-Breaks: libzycore1.4 (<< ${source:Version})
+Package: libzycore1.5
 Architecture: any
 Multi-Arch: same
 Depends: ${misc:Depends},
@@ -34,7 +29,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libzycore1.4t64 (= ${binary:Version}),
+Depends: libzycore1.5 (= ${binary:Version}),
          ${misc:Depends}
 Recommends: libzycore-doc
 Description: Zyan Core Library for C - development
@@ -54,3 +49,4 @@
  macros and a fallback for environments without LibC.
  .
  This package contains the generated Doxygen documentation.
+

=== debian/rules ===
#!/usr/bin/make -f

# optimize=-lto because zycore handles LTO in CMake
export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto qa=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DBUILD_SHARED_LIBS=ON \
		-DZYAN_WHOLE_PROGRAM_OPTIMIZATION=ON \
		-DZYCORE_BUILD_SHARED_LIB=ON 

override_dh_installdocs-indep:
	dh_installdocs --indep --doc-main-package=libzycore-doc

override_dh_installexamples-indep:
	dh_installexamples --indep --doc-main-package=libzycore-doc

## zycore-c 1.5.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -9,7 +9,7 @@
     cmake_policy(SET CMP0091 NEW)
 endif ()
 
-project(Zycore VERSION 1.4.0.0 LANGUAGES C)
+project(Zycore VERSION 1.5.1.0 LANGUAGES C)
 
 include(GNUInstallDirs)
 include(CMakePackageConfigHelpers)
@@ -118,6 +118,7 @@
     add_library("Zycore" STATIC)
     target_compile_definitions("Zycore" PUBLIC "ZYCORE_STATIC_BUILD")
 endif ()
+add_library("Zycore::Zycore" ALIAS "Zycore")
 
 set_target_properties("Zycore" PROPERTIES
     LINKER_LANGUAGE C
@@ -228,10 +229,16 @@
 
 find_package(Doxygen)
 if (DOXYGEN_FOUND)
+    set(DOXYGEN_GENERATE_MAN YES)
     doxygen_add_docs(ZycoreDoc "include/Zycore/" ALL)
     install(
         DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/html/"
         DESTINATION "${CMAKE_INSTALL_DOCDIR}/api"
+        COMPONENT Documentation
+    )
+    install(
+        DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/man/man3/"
+        DESTINATION "${CMAKE_INSTALL_MANDIR}/man3"
         COMPONENT Documentation
     )
 endif()

=== meson_options.txt ===
option(
  'nolibc',
  type: 'boolean',
  value: false,
  description: 'Do not use any C standard library functions (for exotic build-envs like kernel drivers)',
  yield: true,
)
option(
  'doc',
  type: 'feature',
  value: 'auto',
  description: 'Build doxygen documentation (requires Doxygen)',
)
option(
  'examples',
  type: 'feature',
  value: 'auto',
  description: 'Build examples',
)
option(
  'tests',
  type: 'feature',
  value: 'auto',
  description: 'Build tests',
)

=== debian/changelog ===
zycore-c (1.5.1-1) unstable; urgency=low

  * New upstream version 1.5.1
  * Upload to unstable
  * First dgit upload
  * d/control: apply X-Style: black
  * d/control: declare dpkg-build-api = 1
  * d/.symbols: add missing Build-Depends-Package.
    Thanks to Bastian for the report!

 -- Andrea Pappacoda <andrea@pappacoda.it>  Tue, 14 Jan 2025 22:48:30 +0100

zycore-c (1.5.0-1) experimental; urgency=medium

  * New upstream version 1.5.0
  * d/control: libzycore1.4t64 -> libzycore1.5
  * d/libzycore-doc.manpages: install manpages
  * d/patches: drop upstreamed patches

 -- Andrea Pappacoda <andrea@pappacoda.it>  Sun, 10 Mar 2024 12:47:38 +0100

=== debian/control ===
Source: zycore-c
Section: libs
Priority: optional
Maintainer: Andrea Pappacoda <andrea@pappacoda.it>
Build-Depends:
 debhelper-compat (= 13),
 dpkg-build-api (= 1),
 dpkg-dev (>= 1.22.5),
Build-Depends-Arch:
 cmake,
 libgtest-dev <!nocheck>,
Build-Depends-Indep:
 cmake,
 doxygen <!nodoc>,
 graphviz <!nodoc>,
 libgtest-dev <!nocheck>,
Standards-Version: 4.7.0
Homepage: https://github.com/zyantific/zycore-c
Vcs-Git: https://salsa.debian.org/debian/zycore-c.git
Vcs-Browser: https://salsa.debian.org/debian/zycore-c
X-Style: black

Package: libzycore1.5
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Zyan Core Library for C
 Zyan Core is an internal library providing platform independent types,
 macros and a fallback for environments without LibC.
 .
 This package contains the shared library.

Package: libzycore-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libzycore1.5 (= ${binary:Version}),
 ${misc:Depends},
Recommends:
 libzycore-doc,
Description: Zyan Core Library for C - development
 Zyan Core is an internal library providing platform independent types,
 macros and a fallback for environments without LibC.
 .
 This package contains the development files.

Package: libzycore-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 libjs-jquery,
 ${misc:Depends},
Description: Zyan Core Library for C - documentation
 Zyan Core is an internal library providing platform independent types,
 macros and a fallback for environments without LibC.
 .
 This package contains the generated Doxygen documentation.

=== debian/rules ===
--- 
+++ 
@@ -6,14 +6,26 @@
 %:
 	dh $@
 
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
+  test := true
+else
+  test := false
+endif
+
 override_dh_auto_configure:
 	dh_auto_configure -- \
 		-DBUILD_SHARED_LIBS=ON \
 		-DZYAN_WHOLE_PROGRAM_OPTIMIZATION=ON \
-		-DZYCORE_BUILD_SHARED_LIB=ON 
+		-DZYCORE_BUILD_SHARED_LIB=ON \
+		-DZYCORE_BUILD_TESTS=$(test)
 
 override_dh_installdocs-indep:
 	dh_installdocs --indep --doc-main-package=libzycore-doc
 
 override_dh_installexamples-indep:
 	dh_installexamples --indep --doc-main-package=libzycore-doc
+
+ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
+execute_after_dh_installdocs-indep:
+	dh_doxygen --indep
+endif

## zycore-c 1.5.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -9,7 +9,7 @@
     cmake_policy(SET CMP0091 NEW)
 endif ()
 
-project(Zycore VERSION 1.5.1.0 LANGUAGES C)
+project(Zycore VERSION 1.5.2.0 LANGUAGES C)
 
 include(GNUInstallDirs)
 include(CMakePackageConfigHelpers)
@@ -124,7 +124,8 @@
     LINKER_LANGUAGE C
     VERSION "${Zycore_VERSION}"
     SOVERSION "${Zycore_VERSION_MAJOR}.${Zycore_VERSION_MINOR}"
-    DEFINE_SYMBOL "ZYCORE_SHOULD_EXPORT")
+    DEFINE_SYMBOL "ZYCORE_SHOULD_EXPORT"
+    C_VISIBILITY_PRESET hidden)
 target_include_directories("Zycore"
     PUBLIC
         $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>

=== debian/changelog ===
zycore-c (1.5.2-1) unstable; urgency=low

  * New upstream version 1.5.2
  * d/control: use my @debian.org email address
  * d/README.source: document packaging workflow
  * d/rules: always use CMake to build
  * d/.symbols: mark private symbols as optional

 -- Andrea Pappacoda <tachi@debian.org>  Sun, 06 Apr 2025 22:01:26 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: zycore-c
 Section: libs
 Priority: optional
-Maintainer: Andrea Pappacoda <andrea@pappacoda.it>
+Maintainer: Andrea Pappacoda <tachi@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
  dpkg-build-api (= 1),
@@ -14,7 +14,7 @@
  doxygen <!nodoc>,
  graphviz <!nodoc>,
  libgtest-dev <!nocheck>,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://github.com/zyantific/zycore-c
 Vcs-Git: https://salsa.debian.org/debian/zycore-c.git
 Vcs-Browser: https://salsa.debian.org/debian/zycore-c

=== debian/rules ===
--- 
+++ 
@@ -4,7 +4,7 @@
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto qa=+all
 
 %:
-	dh $@
+	dh $@ --buildsystem=cmake
 
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
   test := true
